#ifndef RTT_TARGET_gnulinux_H
#define RTT_TARGET_gnulinux_H

#define OROCFG_CORELIB_REALTIME_TOOLKIT 1
#define OROCFG_CORELIB_REALTIME_TOOLKIT_IMPORT 1

/* #undef OS_NO_ASM */
#ifdef OS_NO_ASM
#define OROBLD_OS_NO_ASM
#endif

#define OS_AGNOSTIC
#ifdef OS_AGNOSTIC
#define OROBLD_OS_AGNOSTIC
#endif

#define ORONUM_OS_MAX_THREADS 8
#define OROSEM_OS_PERIODIC_THREADS_MAX_OVERRUN -1
#define OROSEM_OS_LOCK_MEMORY 1

#define ORO_ACT_DEFAULT_ACTIVITY
/* #undef ORO_ACT_DEFAULT_SEQUENTIAL */
#define OS_HAVE_MAIN
#define OS_HAVE_IOSTREAM
#define OS_HAVE_STREAMS
/* #undef OS_THREAD_SCOPE */
#define OS_RT_MALLOC
#ifdef OS_THREAD_SCOPE
#define OROPKG_OS_THREAD_SCOPE
#endif

/* #undef ORO_OS_USE_BOOST_THREAD */
#ifdef ORO_OS_USE_BOOST_THREAD
#define BOOST_DATE_TIME_POSIX_TIME_STD_CONFIG
#endif

/* #undef CONFIG_FORCE_UP */

/* #undef ORO_SIGNALLING_OPERATIONS */
/* #undef ORO_SIGNALLING_PORTS */

/* #undef OS_EMBEDDED */
#ifdef OS_EMBEDDED
#define ORO_EMBEDDED
#endif

/* #undef OS_NOEXCEPTIONS */
#ifdef OS_NOEXCEPTIONS
#define ORO_OS_NOEXCEPTIONS
#endif

#if !defined(OS_EMBEDDED) || defined(OS_EMBEDDED_SCRIPTING)
#define OROPKG_EXECUTION_PROGRAM_PARSER
#endif

#define PLUGINS_ENABLE_SCRIPTING

#define ORO_REMOTING

/* #undef OROBLD_DISABLE_LOGGING */
/* #undef OROSEM_PRINTF_LOGGING */
#define OROSEM_FILE_LOGGING
#define OROSEM_REMOTE_LOGGING
#define ORONUM_LOGGING_BUFSIZE 1000

#define OROPKG_OS
#define OROPKG_CORELIB_EVENTS
#define OROPKG_CORELIB_REPORTING
#define OROPKG_DEVICE_INTERFACE

#define OROPKG_EXECUTION
#define OROPKG_EXECUTION_ENGINE 1
#define OROPKG_EXECUTION_PROGRAM_PROCESSOR
#define OROPKG_EXECUTION_ENGINE_EVENTS
#define OROPKG_EXECUTION_ENGINE_COMMANDS
#define OROPKG_EXECUTION_ENGINE_PROGRAMS
#define OROPKG_EXECUTION_ENGINE_STATEMACHINES
#define ORONUM_EXECUTION_PROC_QUEUE_SIZE 16

/** If marshalling is enabled, use these defines. */
#define PLUGINS_ENABLE_MARSHALLING
#ifdef PLUGINS_ENABLE_MARSHALLING
/* #undef OROPKG_SUPPORT_XERCES_C */
#define OROPKG_CORELIB_PROPERTIES_MARSHALLING
#define OROPKG_CORELIB_PROPERTIES_MARSHALLING_CPF 1
#define ORODAT_CORELIB_PROPERTIES_MARSHALLING_INCLUDE "marsh/CPFMarshaller.hpp"
#define OROCLS_CORELIB_PROPERTIES_MARSHALLING_DRIVER CPFMarshaller
#define ORODAT_CORELIB_PROPERTIES_DEMARSHALLING_INCLUDE "marsh/TinyDemarshaller.hpp"
#define OROCLS_CORELIB_PROPERTIES_DEMARSHALLING_DRIVER TinyDemarshaller
#endif

// Target detection macros for users:
// Backwards compatibility:
#define OROPKG_OS_GNULINUX

// New format:
#define OROCOS_TARGET_GNULINUX 1

#define OROCOS_TARGET_NAME "gnulinux"

// Safety check:
#ifndef OROPKG_OS_GNULINUX
#error "Configuration error: OROPKG_OS_GNULINUX not defined !"
#endif

#endif
